zreadrb.c File Reference

Read a matrix stored in Rutherford-Boeing format. More...

`#include <stdio.h>`
`#include <stdlib.h>`
`#include "slu_zdefs.h"`
Include dependency graph for zreadrb.c:

## Functions

static int | zDumpLine (FILE *fp)
| Eat up the rest of the current line. More...
static int | zParseIntFormat (char *buf, int *num, int *size)
static int | zParseFloatFormat (char *buf, int *num, int *size)
static int | ReadVector (FILE *fp, int n, int_t *where, int perline, int persize)
static int | zReadValues (FILE *fp, int n, doublecomplex *destination, int perline, int persize)
| Read complex numbers as pairs of (real, imaginary) More...
static void | FormFullA (int n, int_t *nonz, doublecomplex **nzval, int_t **rowind, int_t **colptr)
void | zreadrb (int *nrow, int *ncol, int_t *nonz, doublecomplex **nzval, int_t **rowind, int_t **colptr)

## Detailed Description

Copyright (c) 2003, The Regents of the University of California, through Lawrence Berkeley National Laboratory (subject to receipt of any required approvals from U.S. Dept. of Energy)

All rights reserved.

The source code is distributed under BSD license, see the file License.txt at the top-level directory.

    -- SuperLU routine (version 4.0) --
    Lawrence Berkeley National Laboratory.
    June 30, 2009

# Purpose

    Read a DOUBLE COMPLEX PRECISION matrix stored in Rutherford-Boeing format
    as described below.

    Line 1 (A72, A8)
         Col. 1 - 72   Title (TITLE)
         Col. 73 - 80  Matrix name / identifier (MTRXID)

    Line 2 (I14, 3(1X, I13))
         Col. 1 - 14   Total number of lines excluding header (TOTCRD)
         Col. 16 - 28  Number of lines for pointers (PTRCRD)
         Col. 30 - 42  Number of lines for row (or variable) indices (INDCRD)
         Col. 44 - 56  Number of lines for numerical values (VALCRD)

    Line 3 (A3, 11X, 4(1X, I13))
         Col. 1 - 3    Matrix type (see below) (MXTYPE)
         Col. 15 - 28  Compressed Column: Number of rows (NROW)
                       Elemental: Largest integer used to index variable (MVAR)
         Col. 30 - 42  Compressed Column: Number of columns (NCOL)
                       Elemental: Number of element matrices (NELT)
         Col. 44 - 56  Compressed Column: Number of entries (NNZERO)
                       Elemental: Number of variable indeces (NVARIX)
         Col. 58 - 70  Compressed Column: Unused, explicitly zero
                       Elemental: Number of elemental matrix entries (NELTVL)

    Line 4 (2A16, A20)
         Col. 1 - 16   Fortran format for pointers (PTRFMT)
         Col. 17 - 32  Fortran format for row (or variable) indices (INDFMT)
         Col. 33 - 52  Fortran format for numerical values of coefficient matrix
                       (VALFMT)
                       (blank in the case of matrix patterns)

    The three character type field on line 3 describes the matrix type.
    The following table lists the permitted values for each of the three
    characters. As an example of the type field, RSA denotes that the matrix
    is real, symmetric, and assembled.

    First Character:
         R Real matrix
         C Complex matrix
         I integer matrix
         P Pattern only (no numerical values supplied)
         Q Pattern only (numerical values supplied in associated auxiliary value
           file)

    Second Character:
         S Symmetric
         U Unsymmetric
         H Hermitian
         Z Skew symmetric
         R Rectangular

    Third Character:
         A Compressed column form
         E Elemental form

## Function Documentation

## FormFullA()

static void FormFullA | ( | int | n,
|  | int_t * | nonz,
|  | doublecomplex ** | nzval,
|  | int_t ** | rowind,
|  | int_t ** | colptr
| ) |  |

static

    On input, nonz/nzval/rowind/colptr represents lower part of a symmetric
    matrix. On exit, it represents the full matrix with lower and upper parts.

Here is the call graph for this function:

## ReadVector()

static int ReadVector | ( | FILE * | fp,
|  | int | n,
|  | int_t * | where,
|  | int | perline,
|  | int | persize
| ) |  |

static

## zDumpLine()

static int zDumpLine | ( | FILE * | fp | ) |

static

## zParseFloatFormat()

static int zParseFloatFormat | ( | char * | buf,
|  | int * | num,
|  | int * | size
| ) |  |

static

## zParseIntFormat()

static int zParseIntFormat | ( | char * | buf,
|  | int * | num,
|  | int * | size
| ) |  |

static

## zreadrb()

void zreadrb | ( | int * | nrow,
|  | int * | ncol,
|  | int_t * | nonz,
|  | doublecomplex ** | nzval,
|  | int_t ** | rowind,
|  | int_t ** | colptr
| ) |  |

Here is the call graph for this function:

## zReadValues()

static int zReadValues | ( | FILE * | fp,
|  | int | n,
|  | doublecomplex * | destination,
|  | int | perline,
|  | int | persize
| ) |  |

static